package categoryhttp

import (
	"fmt"
	authmiddleware "legalgo-BE-go/internal/api/http/middleware/auth"
	categorydomain "legalgo-BE-go/internal/domain/category"
	categorysvc "legalgo-BE-go/internal/services/category"
	"legalgo-BE-go/internal/utilities/response"
	"legalgo-BE-go/internal/utilities/utils"
	"net/http"

	"github.com/go-chi/chi/v5"
	"github.com/go-playground/validator/v10"
)

func Update(
	router chi.Router,
	validate *validator.Validate,
	categorySvc categorysvc.Category,
) {
	router.
		With(authmiddleware.Authorize()).
		Put("/category/{category_id}/update", func(w http.ResponseWriter, r *http.Request) {
			ctx := r.Context()
			categoryID := chi.URLParam(r, "category_id")

			if categoryID == "" {
				response.RespondJsonErrorWithCode(
					ctx,
					w,
					fmt.Errorf("category id is not provided"),
					response.ErrBadRequest.Code,
					response.ErrBadRequest.HttpCode,
					"category id is not provided",
				)
				return
			}

			var spec categorydomain.CategoryReq
			if err := utils.UnmarshalBody(r, &spec); err != nil {
				response.RespondJsonErrorWithCode(
					ctx,
					w,
					err,
					response.ErrBadRequest.Code,
					response.ErrBadRequest.HttpCode,
					"failed to unmarshal body",
				)
				return
			}

			if err := validate.Struct(spec); err != nil {
				response.RespondJsonErrorWithCode(
					ctx,
					w,
					err,
					response.ErrBadRequest.Code,
					response.ErrBadRequest.HttpCode,
					err.(validator.ValidationErrors).Error(),
				)
				return
			}

			if err := categorySvc.Update(categoryID, spec); err != nil {
				response.RespondJsonErrorWithCode(
					ctx,
					w,
					err,
					response.ErrBadRequest.Code,
					response.ErrBadRequest.HttpCode,
					err.Error(),
				)
				return
			}

			response.RespondJsonSuccess(ctx, w, struct {
				Message string
			}{
				Message: "update category success",
			})
		})
}
